package tutorial.dao;

import java.util.List;

import javax.persistence.Query;

import org.springframework.orm.jpa.support.JpaDaoSupport;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import tutorial.service.CommonService;

import org.apache.commons.logging.*;

/**
 * <b>Created:</b> Feb 27, 2008<br>
 * <b>Title:</b> CommonDao<br>
 * <b>Description:</b><br>
 * <b>Copyright:</b> Copyright (c) 2008<br>
 * @author MTyson
 * <p>
 * @todo add class overview here
 */

public class CommonDao extends JpaDaoSupport implements CommonService{
    private static final transient Log log = LogFactory.getLog(tutorial.dao.CommonDao.class);

    /**default empty constructor*/
    public CommonDao() {
    }
    
    @Transactional
    public Object save(Object o){
        if (log.isInfoEnabled()) { log.info("BEGIN save(): " + o); }
//        if (getJpaTemplate().contains(o)){
//            getJpaTemplate().merge(o);
//        } else {
//            getJpaTemplate().persist(o);
//        }
        o = getJpaTemplate().merge(o);
        if (log.isInfoEnabled()) { log.info("Object saved.  RETURNING o: " + o); }
        return o;
    }
    
    public Object get(Class clazz, Long id){
        return getJpaTemplate().find(clazz, id);
    }
    
    public Long getCount(Class clazz){
        if (log.isInfoEnabled()) { log.info("BEGIN getCount(): " + clazz); }
        String className = clazz.getName();
        Query query = getJpaTemplate().getEntityManagerFactory().createEntityManager()
            .createQuery("select count(*) from " + className); // Use * to avoid Hibernate error with count() on alias in HQL
        Long count = (Long)query.getSingleResult();
       
        if (log.isInfoEnabled()) { log.info("RETURNING count: " + count); }
        return count;
    }
    @Transactional ( propagation = Propagation.REQUIRED, readOnly = false )
    public void flush(){
        this.getJpaTemplate().flush();
    }
    
    public List<Object> getAll(Class clazz){
        return getJpaTemplate().find(" from " + clazz.getName());
    }
}
