package tutorial.model;


import org.apache.commons.logging.*;
import org.hibernate.dialect.InformixDialect;

import javax.persistence.*;

/**
 * <b>Created:</b> Feb 26, 2008<br>
 * <b>Title:</b> Developer<br>
 * <b>Description:</b><br>
 * <b>Copyright:</b> Copyright (c) 2008<br>
 * @author MTyson
 * <p>
 * 
 * 
 */
@Entity
public class Developer extends Person implements ManagedObject {
    private static final transient Log log = LogFactory.getLog(tutorial.model.Developer.class);

    @Id
    @GeneratedValue(strategy = GenerationType.TABLE)
    @Column(name = "developer_id")
    private Long developerId;
    
    /**default empty constructor*/
    public Developer() {
    }
    
    public String toString(){
        return "Developer [" + this.getId() + ", " + this.getFirstName() + "]";
    }
    public Long getId(){
        return this.getDeveloperId();
    }
    
    public Developer(String firstName){
        super(firstName);
    }

    public Long getDeveloperId() {
        return developerId;
    }

    public void setDeveloperId(Long developerId) {
        this.developerId = developerId;
    }
    
    public boolean equals(Object o){
        if (log.isInfoEnabled()) { log.info("BEGIN equals: I AM: " + this + " | o IS: " + o); }
        boolean e = false;
        if (o instanceof Developer){
            ManagedObject mo = (ManagedObject)o;
            if (log.isTraceEnabled()) { log.trace("is instance."); }
            if (this.getId().equals(mo.getId())){
                e = true;
            } 
        }
        if (log.isInfoEnabled()) { log.info("RETURN e: " + e); }
        return e;
    }
    public int hashCode(){
        return (this.getId().intValue() / 10) / 20 * 47;
    }
}
