package tutorial.model;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.annotations.Cascade;

//import org.apache.commons.logging.*;

/**
 * <b>Created:</b> Apr 18, 2008<br>
 * <b>Title:</b> PathProxy<br>
 * <b>Description:</b><br>
 * <b>Copyright:</b> Copyright (c) 2008<br>
 * @author MTyson
 * <p>
 * @todo add class overview here
 */
@Entity
public class PathProxy {
    //private static final transient Log log = LogFactory.getLog(tutorial.model.PathProxy.class);
    
    public static final String ENTITY_TYPE_PROPERTY = "entityType";
    public static final String ENTITY_ID_PROPERTY = "entityId";

    @Id
    @GeneratedValue(strategy = GenerationType.TABLE)
    @Column(name = "path_proxy_id")
    private Long pathProxyId;
    @Column(name = "entity_type")
    private String entityType;
    @Column(name = "entity_id")
    private Long entityId;
    @ManyToOne
    @JoinColumn(name="parent_id")
    private PathProxy parent;
    @OneToMany(cascade=CascadeType.ALL, mappedBy="parent")
    private List<PathProxy> children;
    
    public String toString(){
        return "PathProxy [id: " + this.getPathProxyId() + ", entity: <" + this.getEntityType() + ", " + this.getEntityId() + ">, " + "parent: " + this.getParent();
    }
    
    public List<PathProxy> getChildren() {
        return children;
    }

    public void setChildren(List<PathProxy> children) {
        this.children = children;
    }

    public Long getPathProxyId() {
        return pathProxyId;
    }

    public void setPathProxyId(Long pathProxyId) {
        this.pathProxyId = pathProxyId;
    }

    public Long getEntityId() {
        return entityId;
    }

    public void setEntityId(Long entityId) {
        this.entityId = entityId;
    }

    public String getEntityType() {
        return entityType;
    }

    public void setEntityType(String entityType) {
        this.entityType = entityType;
    }

    public PathProxy getParent() {
        return parent;
    }

    public void setParent(PathProxy parent) {
        this.parent = parent;
    }

    /**default empty constructor*/
    public PathProxy() {
    }

}
