package tutorial.webapp.jsf.convert;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import tutorial.model.Manager;
import tutorial.model.ManagedObject;
import tutorial.service.CommonService;

import org.apache.commons.logging.*;

/**
 * <b>Created:</b> Apr 18, 2008<br>
 * <b>Title:</b> ManagerConverter<br>
 * <b>Description:</b><br>
 * <b>Copyright:</b> Copyright (c) 2008<br>
 * @author MTyson
 * <p>
 * @todo add class overview here
 */

public class ManagedObjectConverter implements Converter {
    private static final transient Log log = LogFactory.getLog(tutorial.webapp.jsf.convert.ManagedObjectConverter.class);

    /**default empty constructor*/
    public ManagedObjectConverter() {
    }
    

    public Object getAsObject(FacesContext context, UIComponent arg1, String typeAndId)
            throws ConverterException {
        if (log.isInfoEnabled()) { log.info("BEGIN getAsObject: " + typeAndId); }
        CommonService commonService = (CommonService)context.getApplication().createValueBinding("#{commonService}").getValue(context);
        String[] split = typeAndId.split("\\^");
        String type = split[0];
        String id = split[1];
        
        Class clazz = null;
        try {
            clazz = Class.forName(type);
        } catch (Exception e) {
            throw new RuntimeException("Unknown type: " + type, e);
        }
        
        Object o = commonService.get(clazz, Long.valueOf(id));
        if (log.isInfoEnabled()) { log.info("RETURNING o: " + o); }
        return o;
    }

    public String getAsString(FacesContext arg0, UIComponent arg1, Object o)
            throws ConverterException {
        ManagedObject mo = (ManagedObject)o;
        String asString = mo.getClass().getName() + "^" + mo.getId();
        if (log.isInfoEnabled()) { log.info("RETURNING asString: " + asString); }
        return asString;
    }

}
